sys = require("sys")
exec = require("child_process").exec

exports.Displayer = class
  constructor: (@args) ->
    @task = @args[2]
    @servers = {}
    @jobIndex = 1
    @jobIndexDone = 0
    @startTime = +new Date()
    @errors = []
    
    process.on "exit", =>
      duration = +new Date() - @startTime
      console.log "\n\033[0;30mcapoo: \033[1;37;40m #{@task} \033[0;32m done in \033[1;32m#{(duration/1000).toFixed(1)} seconds!\033[m"
    
  updateScreen: ->
    sys.print "\033[2J"
    sys.print "\033[0;30mcapoo: \033[1;37mRunning capistrano task \033[1;37;40m #{@task} \033[m\n"
    
    if @command
      sys.print "\033[0;30mcapoo: \033[1;37mExecuting command: \033[1;37;40m #{@command} \033[m\n"
      
    sys.print "\n"
    
    # update screen
    for host, data of @servers
      sys.print "\033[0;30m#{host}:\t\033[1;#{if data.done is true then 32 else 37}m #{data.message}\033[m\n"
      
    for error in @errors
      sys.print error
  
  parseData: (data) ->
    # server listing
    if match = data.match /servers: (.*)/i
      servers = JSON.parse match[1] 
      for server in servers
        @servers[server] = 
          message: "Connecting..."
          done: false
          job: @jobIndex
      @jobIndex++
        
    # output
    if matches = data.match /\*\* \[out :: (.*)\] (.*)/ig
      line = matches[matches.length-1]
      match = line.match /\*\* \[out :: (.*)\] (.*)/i
      if @servers[match[1]]
        @servers[match[1]].message = match[2]
      else
        @servers[match[1]] = 
          message: match[2]
            
    if match = data.match /\* executing \"(.*)\"/i
      @command = match[1]
    
    if matches = data.match /\*\* \[err :: (.*)\] (.*)/ig
      line = matches[matches.length-1]
      match = line.match /\*\* \[err :: (.*)\] (.*)/i
      if @servers[match[1]]
        @servers[match[1]].message = "\033[0;31mError: #{match[2]}\033[m"
      else
        @servers[match[1]] =
          message: "\033[0;31m#{match[2]}\033[m"
        
    # command finished
    if match = data.match /command finished/i
      for host, data of @servers
        if data.job is @jobIndexDone+1
          @servers[host].done = true
      @jobIndexDone++
    
    @updateScreen()
  
  run: ->
    @process = exec "cap #{@task}"
    
    @process.stdout.on "data", (data) =>
      console.log data.toString()      
    
    @process.stderr.on "data", (data) =>
      @parseData data.toString()