var exec, sys;
var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; }, __hasProp = Object.prototype.hasOwnProperty;
sys = require("sys");
exec = require("child_process").exec;
exports.Displayer = function() {
  function _Class(args) {
    this.args = args;
    this.task = this.args[2];
    this.servers = {};
    this.jobIndex = 1;
    this.jobIndexDone = 0;
    this.startTime = +new Date();
    this.errors = [];
    process.on("exit", __bind(function() {
      var duration;
      duration = +new Date() - this.startTime;
      return console.log("\n\033[0;30mcapoo: \033[1;37;40m " + this.task + " \033[0;32m done in \033[1;32m" + ((duration / 1000).toFixed(1)) + " seconds!\033[m");
    }, this));
  }
  _Class.prototype.updateScreen = function() {
    var data, error, host, _i, _len, _ref, _ref2, _results;
    sys.print("\033[2J");
    sys.print("\033[0;30mcapoo: \033[1;37mRunning capistrano task \033[1;37;40m " + this.task + " \033[m\n");
    if (this.command) {
      sys.print("\033[0;30mcapoo: \033[1;37mExecuting command: \033[1;37;40m " + this.command + " \033[m\n");
    }
    sys.print("\n");
    _ref = this.servers;
    for (host in _ref) {
      if (!__hasProp.call(_ref, host)) continue;
      data = _ref[host];
      sys.print("\033[0;30m" + host + ":\t\033[1;" + (data.done === true ? 32 : 37) + "m " + data.message + "\033[m\n");
    }
    _ref2 = this.errors;
    _results = [];
    for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
      error = _ref2[_i];
      _results.push(sys.print(error));
    }
    return _results;
  };
  _Class.prototype.parseData = function(data) {
    var host, line, match, matches, server, servers, _i, _len, _ref;
    if (match = data.match(/servers: (.*)/i)) {
      servers = JSON.parse(match[1]);
      for (_i = 0, _len = servers.length; _i < _len; _i++) {
        server = servers[_i];
        this.servers[server] = {
          message: "Connecting...",
          done: false,
          job: this.jobIndex
        };
      }
      this.jobIndex++;
    }
    if (matches = data.match(/\*\* \[out :: (.*)\] (.*)/ig)) {
      line = matches[matches.length - 1];
      match = line.match(/\*\* \[out :: (.*)\] (.*)/i);
      if (this.servers[match[1]]) {
        this.servers[match[1]].message = match[2];
      } else {
        this.servers[match[1]] = {
          message: match[2]
        };
      }
    }
    if (match = data.match(/\* executing \"(.*)\"/i)) {
      this.command = match[1];
    }
    if (matches = data.match(/\*\* \[err :: (.*)\] (.*)/ig)) {
      line = matches[matches.length - 1];
      match = line.match(/\*\* \[err :: (.*)\] (.*)/i);
      if (this.servers[match[1]]) {
        this.servers[match[1]].message = "\033[0;31mError: " + match[2] + "\033[m";
      } else {
        this.servers[match[1]] = {
          message: "\033[0;31m" + match[2] + "\033[m"
        };
      }
    }
    if (match = data.match(/command finished/i)) {
      _ref = this.servers;
      for (host in _ref) {
        if (!__hasProp.call(_ref, host)) continue;
        data = _ref[host];
        if (data.job === this.jobIndexDone + 1) {
          this.servers[host].done = true;
        }
      }
      this.jobIndexDone++;
    }
    return this.updateScreen();
  };
  _Class.prototype.run = function() {
    this.process = exec("cap " + this.task);
    this.process.stdout.on("data", __bind(function(data) {
      return console.log(data.toString());
    }, this));
    return this.process.stderr.on("data", __bind(function(data) {
      return this.parseData(data.toString());
    }, this));
  };
  return _Class;
}();